var wsUrl = 'http://app.portablediscounts.com/pdwebservice.asmx';
var wsNamespace = 'http://tempuri.org/';
var did = '';           //5fe50380-02d2-419e-9cad-0f94d3b91ac6
var cardNo = '';        //2A5355D67406
var showTerms = true;
var OfferList;
var SelectedOffer;
var zipCode;
var RedeemedList;
var TeamGraphic;
var DeviceInfo;
var ShowingBanner = 5;
var BannerTimer;
var redeemedOffer;

// This event handler is fired once the intel libraries are ready
//function onDeviceReady() {
//    document.addEventListener('intel.xdk.notification.confirm', confirmResponse, false);

 //   did = intel.xdk.cache.getCookie('did');
    
    
    //cardNo = intel.xdk.cache.getCookie('cardNo');
   
    //hide splash screen now that our app is ready to run
//    setTimeout(function (){
//               $.ui.launch();
//              intel.xdk.device.hideSplashScreen();
              //$.ui.removeFooterMenu();
//              $.ui.disableSideMenu();
              //$.ui.showBackButton = false;
//              $.ui.toggleSideMenu(false);//Force the menu to hide
//              $.ui.blockUI(0.9);
 //               $.ui.useOSThemes=false;
  //            wsValidateDeviceId(endValidateDeviceId);
//              }, 50);


//}


function showFooterMenu() {
    document.getElementById("navbar").style.display = 'inline';
    document.getElementById("content").style.bottom = "49px";
}
function hideFooterMenu() {
    document.getElementById("navbar").style.display = 'none';
    document.getElementById("content").style.bottom = "0px";
}

function goBack() {
     window.history.back()
     //document.getElementById("btnBack").disabled = "true";
     
 }



//Gets the inner text of a single node.
function GetElement(response, nodeName)
{
    var result = undefined;
    if (typeof response == 'string')
    {
        //The Intel XDK does not return an XML object.
        //It returns the response as a string, so we 
        //have to parse it on our own.
        var s = new String(response);

        var o = s.indexOf("<" + nodeName + ">");
        var c = s.indexOf("</" + nodeName + ">");
        if (o>=0 && c>o)
        {
            result = s.substr(o + nodeName.length + 2, c - o - nodeName.length - 2);
        }
        else
        {
            //Check for empty node
            o = s.indexOf("<" + nodeName + " />");
            if(o>=0)
            {
                result = "";
            }
        }
    }
    else
    {
        var s1 = response.getElementsByTagName(nodeName);
        if (s1.length>0)
        {
            if(s1[0].childNodes.length>0)
            {
                result = s1[0].childNodes[0].nodeValue;
            }
            else   
            {
                //Node is empty
                result = "";
            }
        }
    }
    return result;
}

//Gets an array of complex elements from the XML string inside the
//specified 'nodeName'.  Note the XML structure needs to be fairly simple
//with just nodes that have inner text.  Empty nodes are allowed.  Nodes
//should not have any attributes or sub-nodes.
//
//For example:
//
//var response =   "<CONTACTS>
//                      <CONTACT>
//                          <FirstName>Chris</FirstName>
//                          <LastName>Morgan</LastName>
//                      </CONTACT>
//                      <CONTACT>
//                          <FirstName>Sheri</FirstName>
//                          <LastName>Morgan</LastName>
//                      </CONTACT>
//                  </CONTACTS>
//var contacts = GetComplexElements(response, "CONTACT");
//
//Will create an array of object.  Eech object will have properties of
//  FirstName and LastName.   
//
//These can be accessed like: contacts[0].FirstName
//
function GetComplexElements(response, nodeName)
{
    var result = new Array();
    var itemText;
    var item;
    
    if (typeof response == 'string')
    {
        //The Intel XDK does not return an XML object.
        //It returns the response as a string, so we 
        //have to parse it on our own.
        var s = response.trim();
        var startTag = 0;
        var endTag, itemOpenTag, itemCloseTag, itemEndTag;


        while (s!="")
        {
            startTag = s.indexOf("<" + nodeName + ">");
            endTag = s.indexOf("</" + nodeName + ">");
            if (startTag>=0 && endTag>startTag)
            {
                item = new Object();
                itemText = s.substr(startTag + nodeName.length + 2, endTag - startTag - nodeName.length).trim();
                s = s.substr(endTag + nodeName.length + 3).trim();

                
                while (itemText!="")
                {
                    itemOpenTag = itemText.indexOf("<");
                    itemCloseTag = itemText.indexOf(">");
                    if (itemOpenTag>=0 && itemCloseTag>itemOpenTag)
                    {
                        var propName = itemText.substr(itemOpenTag + 1, itemCloseTag-itemOpenTag-1);
                        if (propName.indexOf('/')>=0)
                        {
                            //empty tag
                            propName = propName.substr(0,propName.length - 2);
                            item[propName] = "";
                            itemText = itemText.substr(itemCloseTag +1);
                        }
                        else
                        {
                            itemEndTag = itemText.indexOf("</" + propName + ">");
                            if (itemEndTag>=0)
                            {
                                var propValue = itemText.substr(itemCloseTag + 1, itemEndTag - itemCloseTag - 1);
                                
                                item[propName] = propValue;
                                
                                itemText = itemText.substr(itemEndTag + propName.length + 3);
                                
                                
                            }
                            else
                            {
                                itemText = "";
                            }
                        }
                        
                    }
                    else
                    {
                        itemText = "";
                    }
                }
                
                result.push(item);
                
            }
            else
            {
                //bad xml format
                s = "";
            }
        }
    }
    else
    {
        //Need to add code to handle XML DOM, which is currently used in the emulator
    }
    return result;
}

//Builds an OPFIVE web service message.
function wsBuildMsg(operation, data)
{
    var msg = '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"> \
    <soap:Body>';

    msg = msg + '<' + operation + ' xmlns="' + wsNamespace + '"> \
    <strUserID>f6d8e2d3-e0a7-4537-b6e6-09d66ee69ac7</strUserID> \
    <strWSPasword>$webserviceuser$</strWSPasword>' +
    data +
    '</' + operation + '>';

    msg = msg + '</soap:Body> \
    </soap:Envelope>';

    return msg;
}

//Generates text that is safe to put inside an XML/HTML node.
function escapeHtml(str) 
{
    var div = document.createElement('div');
    div.appendChild(document.createTextNode(str));
    return div.innerHTML;
};

//Converts an XML/HTML safe string into a regular string.
function htmlDecode(input)
{
    input = input.replace(/&lt;/gm,"<").replace(/&gt;/gm,">").replace(/&amp;/gm,"&");
    return input;
//This does not work, it truncates the data
//    var e = document.createElement('div');
//    e.innerHTML = input;
//    return e.childNodes[0].nodeValue;
}

//Safely encode a soap parameter.
function soapParm(name, value)
{
    var result= '<' + name + '>' + escapeHtml(value) + '</' + name + '>';
    return result;
}

function wsRetrievePassword()
{
    var cardNo = document.getElementById("txtCardId").value.toLowerCase(); ;
    var email = document.getElementById("txtEmail").value.toLowerCase(); ;

    var soapMessage =  wsBuildMsg('RetrievePassword',
                                  soapParm('strCardNo', cardNo) +
                                  soapParm('strEmail', email));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endRetrievePassword,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}

function endRetrievePassword(xmlHttpRequest, status)
{
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'RetrievePasswordResult')=='true')
        {
            navigator.notification.alert('Password sent to email.',confirmRegistrationFailed,'Portable Discounts','OK');
        }
        else
        {
            navigator.notification.alert('Failed to retreive password: ' + GetElement(xmlHttpRequest.responseXML, 'strResponse') + ' Contact service@portablediscounts.com for help.',confirmRegistrationFailed, 'Error', 'OK');
        }
    }
    else
    {
        navigator.notification.alert("Request Failed",confirmRegistrationFailed,"Error",'OK');
    }

}

function wsRedeemOffer()
{
//    cardNo = "1bf7684b-d4b0-46d1-9f31-8fa12b05c541";
//    offerID = 'f6d3bbc5-653d-4096-b39f-54cdbdbb5b52';

    var soapMessage =  wsBuildMsg('Redeem_Offer',
                                  soapParm('strOfferID', SelectedOffer.ID) +
                                  soapParm('strCardNo', cardNo));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endRedeemOffer,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}

function endRedeemOffer(xmlHttpRequest, status)
{
    var redeemCoupon
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'strResponse').toLowerCase()=='true')
        {
            var redeemed = GetComplexElements(htmlDecode( GetElement(xmlHttpRequest.responseText, "Redeem_OfferResult")), "REDEEMEDOFFER");

            if(redeemed.length>0)
            {
                //Redeemed result is in redeemed[0].  Valid items are:
                //  redeemed[0].Offer_Name
                //  redeemed[0].Offer_Details
                //  redeemed[0].Location_Zip
                //  redeemed[0].Disclaimer
                //  redeemed[0].Valid_Locations
                //  redeemed[0].ImgURL


                redeemCoupon = "<div align='center' margin-left='0px' style=''><img src='" + redeemed[0].ImgURL + "' alt='' width='100%' style='padding-top:10px'></div>";
                //intel.xdk.notification.alert("Offer redeemed: " + redeemed[0].Offer_Name,"Second Message",'OK');
                document.getElementById("Coupon").innerHTML = redeemCoupon;
                activate_subpage("#uib_page_couponsub");
                
               
                
                
                
            }
            else
            {
                //This shouldn't happen, if so the web service returned bad data.
                navigator.notification.alert("Failed to redeem offer",confirmNothing,"Error",'OK');
            }

        }
        else
        {
            navigator.notification.alert(GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmNothing,"Error",'OK');
        }
    }
    else
    {
        navigator.notification.alert("Request Failed",confirmNothing,"Error",'OK');
    }

}

function wsValidateDeviceId()
{
    
    var savedDID = "did";
    did = window.localStorage.getItem(savedDID);
   
    var soapMessage =  wsBuildMsg('ValidateDeviceID2',
                                  soapParm('strDeviceID', did));
    
    
    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endValidateDeviceId,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}

var teamLogoLink;

function openTeamPage() {
    
    if (teamLogoLink == 'http://') {

        navigator.notification.alert('School Website Not Provided', confirmNothing,'Portable Discounts', 'OK');
        

    }
    else {
        //intel.xdk.device.launchExternal(teamLogoLink);
        window.open(encodeURI(teamLogoLink), '_system', 'location=no');
        
    }
}

function openBannerPage() {
    //removed this function because it is interfering with entering the zipcode.
    
    /*if (DeviceInfo["Ad_Banner" + (ShowingBanner + 1) + "_URL"].length == 0) {
        //intel.xdk.device.launchExternal("http://www.portablediscounts.com");
        window.open("http://www.portablediscounts.com", '_system', 'location=no');
    }
    else {
        //intel.xdk.device.launchExternal(DeviceInfo["Ad_Banner" + (ShowingBanner + 1) + "_URL"]);
        window.open(encodeURI(DeviceInfo["Ad_Banner" + (ShowingBanner + 1) + "_URL"]), '_system', 'location=no');        
    }*/
}

function ShowBanner()
{
    var bannerString
    
    
    
    if (DeviceInfo["Ad_Banner" + (ShowingBanner + 1)] == 'http://app.portablediscounts.com/') {

        bannerString="<a class='uib-graphic-button bannerSize widget uib_w_46 d-margins' data-uib='media/graphic_button' data-ver='0' href='#' onclick='openBannerPage()'><img src='images/PDLogo.png'><span class='uib-caption'></span></a>"
        
       
        
        document.getElementById("bannerImage").innerHTML = bannerString;

    }
    else {
        bannerString="<a class='uib-graphic-button bannerSize widget uib_w_46 d-margins' data-uib='media/graphic_button' data-ver='0' href='#' onclick='openBannerPage()'><img src= "+DeviceInfo["Ad_Banner" + (ShowingBanner + 1)]+"><span class='uib-caption'></span></a>"
        
        document.getElementById("bannerImage").innerHTML = bannerString;
    }

    if(BannerTimer==undefined)
    {
        BannerTimer = setInterval(NextBanner,10000);
    }
}

function NextBanner()
{
    ShowingBanner = ShowingBanner + 1;
    if(ShowingBanner>=5)
    {
        ShowingBanner = 0;
    }
    ShowBanner();
}

function ManualNextBanner()
{
    clearInterval(BannerTimer);
    BannerTimer = undefined;
    NextBanner();
}

function ManualPrevBanner()
{
    clearInterval(BannerTimer);
    BannerTimer = undefined;
    ShowingBanner = ShowingBanner - 1;
    if(ShowingBanner<0)
    {
        ShowingBanner = ShowingBanner + 5;
    }
    ShowBanner();
}

//Num needs to be 0 - 4
function ManualSetBanner(num)
{
    clearInterval(BannerTimer);
    BannerTimer = undefined;
    ShowingBanner = num;
    ShowBanner();
}

function endValidateDeviceId(xmlHttpRequest, status) { 
    //$.ui.unblockUI();
    
    if (status == 'success') {
        if (GetElement(xmlHttpRequest.responseXML, 'ValidateDeviceID2Result') != '') {
            //var teamLogoImg = GetElement(xmlHttpRequest.responseXML, 'strImgURL');

            //teamLogoLink = GetElement(xmlHttpRequest.responseXML, 'strWebURL');

            //document.getElementById("teamImage").src = teamLogoImg;

            var info = GetComplexElements(htmlDecode(GetElement(xmlHttpRequest.responseText, "ValidateDeviceID2Result")), "OFFER");
            
            var TeamName;
            var TeamLink;
            var TeamImage;

            if(info.length>0)
            {
                DeviceInfo = info[0];

                //Device Info contains:
                //  Activated: "true"
                //  ActivationDate: "03/19/2014"
                //  Ad_Banner1: "http://app.portablediscounts.com/banners/64/banner1.jpg"
                //  Ad_Banner1_URL: 
                //  Ad_Banner2: "http://app.portablediscounts.com/banners/64/banner2.jpg"
                //  Ad_Banner2_URL: 
                //  Ad_Banner3: "http://app.portablediscounts.com/banners/64/banner3.jpg"
                //  Ad_Banner3_URL: 
                //  Ad_Banner4: "http://app.portablediscounts.com/banners/64/banner3.jpg"
                //  Ad_Banner4_URL: 
                //  Ad_Banner5: "http://app.portablediscounts.com/banners/64/banner3.jpg"
                //  Ad_Banner5_URL: 
                //  Card_ID: "39580ce6-aa54-4178-be6f-9623521e1c29"
                //  Card_Name: "Mustangs Discount"
                //  Card_No: "2A5355D67406"
                //  Device_ID: "006f9d0e-b298-4cb9-9634-ec151b9a19f1"
                //  Device_name: "mobile"
                //  Email: "w_chris_morgan@msn.com"
                //  EndDate: "2014-11-25T00:00:00-05:00"
                //  First_Name: "Chris"
                //  ID: "39580ce6-aa54-4178-be6f-9623521e1c29"
                //  ImgURL: "http://app.portablediscounts.com/schools/64/600_logo.jpg"
                //  Last_Name: "Morgan"
                //  Password: "RexxDog"
                //  Registered: "true"
                //  School_ID: "dd5889e2-6953-4d61-bea1-658e04b9576f"
                //  School_Name: "Murdock Elementary"
                //  StartDate: "2013-11-25T00:00:00-05:00"
                //  Validated: "false"
                //  Website: "http://www.cobbk12.org/murdock/index.aspx"

                cardNo = DeviceInfo.Card_No;
                teamLogoLink = DeviceInfo.Website;
                TeamName = DeviceInfo.School_Name;
                
               
    var nearbyButton
    var zipSearch
    var zipInput
    var teamLabel
    
    if (screen.width < 500){
          TeamImage = "<a style='color:#000'class='uib-graphic-button bannerSize widget uib_w_45 d-margins' data-uib='media/graphic_button' data-ver='0' href='#' onclick='openTeamPage();'><img src= "+DeviceInfo.ImgURL+"><span style='color:#000'class='uib-caption'>"+TeamName+"</span></a>"
                document.getElementById("teamImage").innerHTML = TeamImage;
        
         nearbyButton="<a class='button widget uib_w_12 icon target d-margins' style='background:rgb(219, 41, 27); color:white;border-radius:0px; text-align:center; width:100%' data-uib='app_framework/button' data-ver='1' id='btnNearByOffers'>Find Nearby Offers</a>"
        document.getElementById("btnNearByOffersdiv").innerHTML = nearbyButton;
        
        zipSearch ="<a class='button widget uib_w_7 d-margins icon magnifier' style='background:rgb(219, 41, 27); color:white;border-radius:0px;' data-uib='app_framework/button' data-ver='1' id='btnZipSearch'></a>"
        
        document.getElementById("btnZipSearchdiv").innerHTML = zipSearch;
        
        zipInput ="<input class='wide-control' placeholder='Zip Code' type='text' id='txtzipCode'>"
        document.getElementById("txtzipCodediv").innerHTML = zipInput;
        
    }
        
        else{
             
             TeamImage = "<a style='color:#000'class='uib-graphic-button bannerSize widget uib_w_45 d-margins' data-uib='media/graphic_button' data-ver='0' href='#' onclick='openTeamPage();'><img src= "+DeviceInfo.ImgURL+"><span style='font-size:30px;color:#000'class='uib-caption'>"+TeamName+"</span></a>"
                document.getElementById("teamImage").innerHTML = TeamImage;
            
             nearbyButton="<a class='button widget uib_w_12 icon target d-margins' style='background:rgb(219, 41, 27); font-size:30px; color:white;border-radius:0px; text-align:center; height:60px; width:100%' data-uib='app_framework/button' data-ver='1' id='btnNearByOffers'>Find Nearby Offers</a>"
        document.getElementById("btnNearByOffersdiv").innerHTML = nearbyButton;
            
            zipSearch ="<a class='button widget uib_w_7 d-margins icon magnifier' style='height:60px; width:100%; font-size:30px; background:rgb(219, 41, 27); color:white;border-radius:0px;' data-uib='app_framework/button' data-ver='1' id='btnZipSearch'></a>"
        
        document.getElementById("btnZipSearchdiv").innerHTML = zipSearch;
            
            zipInput ="<input class='wide-control' style='height:60px; width:100%; font-size:30px;' placeholder='Zip Code' type='text' id='txtzipCode'>"
        document.getElementById("txtzipCodediv").innerHTML = zipInput;
        
    }

                NextBanner();
            }

            activate_subpage("#uib_page_mainappsub");
           
        }
        else {
            //var profileCardNo = document.getElementById("txtCardId").value;
            //if (profileCardNo != ""){
            //navigator.notification.alert("Card Issue contact service@portablediscounts.com", confirmNothing, "Portable Discounts");
            //}
            //activate_subpage("#uib_page_profilesub");
            var errorResponse = GetElement(xmlHttpRequest.responseText, "strOutput");
            if (errorResponse == "Your card has expired.") {
                navigator.notification.alert(errorResponse + "  Validate Card Failed Please contact support service@portablediscounts.com  ", confirmRegistrationFailed, "Error", 'OK');
            }
            activate_subpage("#uib_page_RegChoicesub");
        }
    }
    else {
        //intel.xdk.notification.confirm(did, "wsValidateDeviceId", "Portable Discounts");
        //navigator.notification.confirm(did, confirmResponse, "Portable Discounts");
        var errorResponse = GetElement(xmlHttpRequest.responseText, "ValidateDeviceID2Result");
        showTerms = false;
        if (errorResponse == 'undefined') {
            navigator.notification.alert("Web service unavailable Please contact support service@portablediscounts.com  "  + errorResponse, confirmRegistrationFailed, "Error", 'OK');
        }
        else {
            navigator.notification.alert("Validate Card Failed Please contact support service@portablediscounts.com  " + errorResponse, confirmRegistrationFailed, "Error", 'OK');
        }

    }

}   
 
function confirmNothing()
{



}

function confirmProfilePage() {

    activate_subpage("#uib_page_profilesub");  
    

}

function confirmRegistrationFailed(){
    
    //activate_subpage("#uib_page_profilesub");  
    activate_subpage("#uib_page_RegChoicesub");
    
}

function confirmValidateDeviceID() {
    
    wsValidateDeviceId;
    
}

function confirmResponse(buttonIndex)
{
    
    if (buttonIndex == 2)
    {
        confirmRegistrationFailed;
    }
    else if (buttonIndex==1)
    {
        
            wsRegisterDevice();
        }
        
        
    }

function wsCheckCardRegistration()
{
    var cardId = document.getElementById("txtCardId").value.toLowerCase();
    var soapMessage =  wsBuildMsg('CheckCardRegistration',
                                  soapParm('strCardNo',cardId));
    
        
    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endCheckCardRegistration,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}



function endCheckCardRegistration(xmlHttpRequest, status)
{  
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseText,'CheckCardRegistrationResult')=='true')
        {    
            if (GetElement(xmlHttpRequest.responseXML,'bolIsCardRegistered')=='true')
            {
                wsDeviceCount();
            }
            else
            {
                wsRegisterCard();
            }
        }
        else
        {
            //$.ui.unblockUI();
            navigator.notification.alert('Card not valid: ' + GetElement(xmlHttpRequest.responseXML, 'strResponse'), confirmRegistrationFailed,'Error', 'OK');
            
        }
    }
    else
    {
        //$.ui.unblockUI();
        var errorResponse = GetElement(xmlHttpRequest.responseText, "CheckCardRegistrationResult");
        navigator.notification.alert("Check Card Request Failed " + errorResponse ,confirmRegistrationFailed, "Error", 'OK');
        
    }

}

function wsReRegister() {
    var email = document.getElementById("txtReEmail").value.toLowerCase();
    var soapMessage = wsBuildMsg('Get_CardID',
                                  soapParm('strEmail', email));


    $.ajax({
        url: wsUrl,
        type: "POST",
        dataType: "xml",
        data: soapMessage,
        complete: endReRegister,
        contentType: "text/xml; charset=\"utf-8\""
    });

    return false;
}

function endReRegister(xmlHttpRequest, status) {
    
    if (status == 'success') {
        //if (GetElement(xmlHttpRequest.responseXML, 'strOutput') == 'Your device ID is valid') {
        var cards = GetComplexElements(htmlDecode(GetElement(xmlHttpRequest.responseText, "Get_CardIDResult")), "CARD");

        var i;
        if (cards.length == 0) {
            navigator.notification.alert('Registration failed ', confirmRegistrationFailed, 'Error', 'OK');
        }
        else {


            for (i = 0; i < cards.length; i++) {
                did = cards[i].ID;
            }
            window.localStorage.setItem('did', did);
            //intel.xdk.cache.setCookie('did',did,-1);
            //intel.xdk.cache.setCookie('cardNo',cardNo,-1);
            wsValidateDeviceId();
        }

        //}
       // else {
            
       //     navigator.notification.alert('Registration failed: ' + GetElement(xmlHttpRequest.responseXML, 'strResponse'), confirmRegistrationFailed, 'Error', 'OK');
       // }
    }
    else {

        var errorResponse = GetElement(xmlHttpRequest.responseText, "RetreiveDevieIDResult");
        
        if (errorResponse == 'undefined') {
            navigator.notification.alert("Web service unavailable Please contact support service@portablediscounts.com" + errorResponse, confirmRegistrationFailed, "Error", 'OK');
        }
        else {
            navigator.notification.alert("Register Card Failed Please contact support service@portablediscounts.com" + errorResponse, confirmRegistrationFailed, "Error", 'OK');
        }
        

    }

}

function wsRegisterCard()
{
    var cardId = document.getElementById("txtCardId").value.toLowerCase();
    var firstName = document.getElementById("txtFirstName").value;
    var lastName = document.getElementById("txtLastName").value;
    var email =  document.getElementById("txtEmail").value.trim();
    var phone = '404-433-9888';
    var password = document.getElementById("txtPassword").value.trim();
    var confirmPassword = document.getElementById("txtConfirmPassword").value.trim();

    if (password=='')
    {
        navigator.notification.alert("Password cannot be blank",confirmProfilePage,"Register Card","OK");
        //$.ui.unblockUI();
    }
    else if (password!==confirmPassword)
    {
        navigator.notification.alert("Passwords don't match", confirmProfilePage, "Register Card", "OK");
       // $.ui.unblockUI();
    }
    else if (firstName=='')
    {
        navigator.notification.alert("First Name cannot be blank", confirmProfilePage, "Register Card", "OK");
        //$.ui.unblockUI();
    }
    else if (lastName=='')
    {
        navigator.notification.alert("Last Name cannot be blank", confirmProfilePage, "Register Card", "OK");
        //$.ui.unblockUI();
    }
    else if (email=='')
    {
        navigator.notification.alert("email cannot be blank", confirmProfilePage, "Register Card", "OK");
        //$.ui.unblockUI();
    }
    else
    {
        var soapMessage =  wsBuildMsg('RegisterCard',
                                      soapParm('strCardNo',cardId) +
                                      soapParm('strFirstName',firstName) +
                                      soapParm('strLastName',lastName) +
                                      soapParm('strEmail',email) +
                                      soapParm('strTelephone',phone) +
                                      soapParm('strUserPassword',password));

        $.ajax({
               url: wsUrl,
               type: "POST",
               dataType: "xml",
               data: soapMessage,
               complete: endRegisterCard,
               contentType: "text/xml; charset=\"utf-8\""
               });

    }
}


function endRegisterCard(xmlHttpRequest, status)
{
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'RegisterCardResult')=='true')
        {
            wsDeviceCount();
        }
        else
        {
            //$.ui.unblockUI();
            navigator.notification.alert('Registration failed: ' + GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmRegistrationFailed,'Error','OK');
        }
    }
    else
    {
        //$.ui.unblockUI();
        navigator.notification.alert("Request Failed",confirmRegistrationFailed,"Error",'OK');
    }

}

function wsRegisterDevice()
{
    var email =  document.getElementById("txtEmail").value.trim();
    var password = document.getElementById("txtPassword").value.trim();
    var deviceName = 'mobile';

    cardNo = document.getElementById("txtCardId").value.toLowerCase();
    
    var soapMessage =  wsBuildMsg('RegisterDevice',
                                  soapParm('strCardNo',cardNo) +
                                  soapParm('strEmail',email) +
                                  soapParm('strDeviceName',deviceName) +
                                  soapParm('strUserPassword',password));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endRegisterDevice,
           contentType: "text/xml; charset=\"utf-8\""
           });

}

function endRegisterDevice(xmlHttpRequest, status)
{
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'RegisterDeviceResult')=='true')
        {
            did = GetElement(xmlHttpRequest.responseXML, 'strDeviceID');
            window.localStorage.setItem('did', did);
            //intel.xdk.cache.setCookie('did',did,-1);
            //intel.xdk.cache.setCookie('cardNo',cardNo,-1);
            wsValidateDeviceId();
            
        }
        else
        {
            //$.ui.unblockUI();
            navigator.notification.alert('Registration failed: ' + GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmRegistrationFailed,'Error','OK');
        }
    }
    else
    {
        //$.ui.unblockUI();
        navigator.notification.alert("Request Failed",confirmRegistrationFailed,"Error",'OK');
    }

}

function wsDeviceCount()
{
    var cardId = document.getElementById("txtCardId").value.toLowerCase();

    var soapMessage =  wsBuildMsg('DeviceCount',
                                  soapParm('strCardNo',cardId));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endDeviceCount,
           contentType: "text/xml; charset=\"utf-8\""
           });

}

function endDeviceCount(xmlHttpRequest, status)
{
    if (status == 'success')
    { 
        var dc = parseInt(GetElement(xmlHttpRequest.responseXML,'DeviceCountResult'));
        if (dc >= 0)
        {
            if (dc==0)
            {
                wsRegisterDevice();
            }
            else
            {
                //$.ui.unblockUI();
                //intel.xdk.notification.confirm("Card has already been registered.  Transfer to this device?","confirmTransferDevice","Portable Discounts","Yes","No");
                navigator.notification.confirm("Card has already been registered.  Transfer to this device?", confirmResponse, "Portable Discounts", ["Yes","No"]);

            }
        }
        else
        {
            //$.ui.unblockUI();
            navigator.notification.alert('Device count error: ' + GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmRegistrationFailed,'Error','OK');
        }
    }
    else
    {
        //$.ui.unblockUI();
        navigator.notification.alert("Request Failed",confirmRegistrationFailed,"Error",'OK');
    }

}


function selectOffer(id)
{
    var find;
    var redeemDiv;
    
    
    

    for(find=0; find<OfferList.length; find++)
    {
        if(OfferList[find].ID==id)
        {
            SelectedOffer = OfferList[find];
            
            
        }
    }
    
    
    
    redeemDiv = "<div align='center' style='text-align:center; padding:5px; color:black; text-decoration:none;'>";
    redeemDiv = redeemDiv + "<p><b><font size='5px'>" + SelectedOffer.Merchant_Name + "</font></b></p>";
    redeemDiv = redeemDiv + "<img src='" + SelectedOffer.ImgURL + "' alt='' style=''>";
    redeemDiv = redeemDiv + "<p><font size='3%'>" + SelectedOffer.Valid_Locations + "</p>"; 
    redeemDiv = redeemDiv + "<p><font size='3%'><b>" + SelectedOffer.Offer_Name + "</b></p>";
    redeemDiv = redeemDiv + "<p><font size='2px'>" + SelectedOffer.Disclaimer + "</font></p>";
    redeemDiv = redeemDiv + "</div>";
        
    
    document.getElementById("offerDetails").innerHTML = redeemDiv;
    activate_subpage("#uib_page_redeemOffersub");
    document.getElementById("btnCancel").className = "icon error";
    document.getElementById("btnRedeem").className = "icon check";
    //showPanel('redeemOffer');
    
    
    //Need to show offer details and provide option to redeem.  Pull info fron SelectedOffer,
    //show the offer details, and provide an option to redeem.  Call wsRedeemOffer() and it will
    //redeem the SelectedOffer.

    //For now just go ahead and redeem it to see what the response is.


}

function openMap() {
    var mapApp
    var mapAddress
    var AddressPlus
    var openMap
    
   
    
    if (SelectedOffer==undefined) 
    {        
        if (RedeemedList==undefined) 
        {            
            navigator.notification.alert("Address not provided",confirmNothing,"Error",'OK');
        }
        else if(redeemedOffer.Address1==undefined)
        {                
            navigator.notification.alert("Address not provided",confirmNothing,"Error",'OK'); 
        }
        else 
        {  
            mapAddress = redeemedOffer.Address1 + "+" + redeemedOffer.City + "+" + redeemedOffer.State + "+" + redeemedOffer.Location_Zip;  
            AddressPlus = mapAddress.replace (/ /g, "+");
            mapApp="http://maps.apple.com/?q=" + mapAddress;
            //mapApp="http://maps.apple.com/?q=2315+Brownstone+Ct+Marietta+GA+30062";
            //intel.xdk.device.launchExternal(mapApp);
            //window.open("http://google.com",  '_local');
            openMap = window.open(encodeURI(mapApp), '_system', 'location=no');
            openMap.show;
            openMap.close;
            
        }
    }
    else if (SelectedOffer.Address1==undefined) 
    {
        navigator.notification.alert("Address not provided",confirmNothing,"Error",'OK'); 
    }
    else 
    {    
      
                     
            mapAddress = SelectedOffer.Address1 + "+" + SelectedOffer.City + "+" + SelectedOffer.State + "+" + SelectedOffer.Location_Zip; 
        AddressPlus = mapAddress.replace (/ /g, "+");
       mapApp="http://maps.apple.com/?q=" + AddressPlus;
        //mapApp="http://maps.apple.com/?q=2315+Brownstone+Ct+Marietta+GA+30062";
        //intel.xdk.device.launchExternal(mapApp);
        openMap = window.open(encodeURI(mapApp), '_system', 'location=no');
        openMap.show;
        openMap.close;
       
        
    }
}

function showRedeemed(id) {
    var find;
    var redeemDiv;
    

    redeemedOffer = RedeemedList[id];


    redeemCoupon = "<div style=''><img src='" + redeemedOffer.ImgURL + "' alt='' width='100%' style=''></div>";
    //intel.xdk.notification.alert("Offer redeemed: " + redeemed[0].Offer_Name,"Second Message",'OK');
    document.getElementById("CouponBack").innerHTML = redeemCoupon;
    //showPanel('offerCoupon')
    activate_subpage("#uib_page_couponBacksub");
    nobtnPressed();
    


}


function wsGetRedeemedOffers()
{
    var soapMessage =  wsBuildMsg('Get_Redeem_Offers',
                                  soapParm('strCardNo', cardNo));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endGetRedeemedOffers,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}

function endGetRedeemedOffers(xmlHttpRequest, status)
{
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'strResponse').toLowerCase()=='true') {
            var offers = GetElement(xmlHttpRequest.responseText, "Get_Redeem_OffersResult");
            if (offers == undefined) {
            var offers = GetElement(xmlHttpRequest.responseText, "Get_Redeem_Offers_24Result");
            }
            RedeemedList = GetComplexElements(htmlDecode( offers ), "REDEEMEDOFFER");

            //Items for redeemed (until Keith adds redeemed/expired date):
            //  redeemed[i].Disclaimer
            //  redeemed[i].ImgURL
            //  redeemed[i].Location_Zip
            //  redeemed[i].Merchant_Name
            //  redeemed[i].Offer_Details
            //  redeemed[i].Offer_Name
            //  redeemed[i].Valid_Locations

            //From here you can build the list and replace the div to show it.
            //var redeemedDiv = "<ul class='list' data-appbuilder-object='list' style=''>";
            var redeemedDiv = "<ul class='list widget uib_w_48 d-margins' data-uib='app_framework/listvie' data-ver='0'>";
            
    var i;
     if(RedeemedList.length==0)
    {
        redeemedDiv = redeemedDiv + "No offers found.";
    }
    else
    {
    
    for (i = 0; i < RedeemedList.length; i++) {
        if (screen.width < 500) {

           // redeemedDiv = redeemedDiv + "<li><div style='text-align:right; padding:5px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(";
            //redeemedDiv = redeemedDiv + '"' + i + '");';
            //redeemedDiv = redeemedDiv + "'><div style='padding-right:5px; padding-bottom:10px'><img src='" + RedeemedList[i].MerchantURL + "' alt='Merchant Name' width='35%' style='float:left;'></div>";
            //redeemedDiv = redeemedDiv + "<div><img src='images/SelectButton.png' alt='' style='float:right; padding-right:0px;'></div>";
            //redeemedDiv = redeemedDiv + "<p> Exp Date: " + RedeemedList[i].ExpDate + "</p>"; 
            ////redeemedDiv = redeemedDiv + "<p>" + escapeHtml(RedeemedList[i].Valid_Locations) + "</p>";
            //redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-top:10px'>" + escapeHtml(RedeemedList[i].Offer_Name) + "</div>";
            //redeemedDiv = redeemedDiv + "</a></div></li>";
            
            
         /* redeemedDiv = redeemedDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
          //redeemedDiv = redeemedDiv + "<div style='text-align:right; padding:5px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(";
            redeemedDiv = redeemedDiv + "<div style='text-align:right'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(";
            redeemedDiv = redeemedDiv + '"' + i + '");';
            //redeemedDiv = redeemedDiv + "'><div style='padding-right:5px; padding-bottom:10px'><img src='" + RedeemedList[i].MerchantURL + "' alt='Merchant Name' width='35%' style='float:left;'></div>";
            redeemedDiv = redeemedDiv + "'><div style='padding-right:5px; padding-bottom:15px'><img src='" + RedeemedList[i].MerchantURL + "' alt='Merchant Name' width='35%' style='float:left;'></div>";
            //redeemedDiv = redeemedDiv + "<div><img src='images/SelectButton.png' alt='' style='float:right; padding-right:0px;'></div>";
            redeemedDiv = redeemedDiv + "<div><img src='images/SelectButton.png' alt='' width='10%' style='float:right'></div>";
            redeemedDiv = redeemedDiv + "<p> Exp Date: " + RedeemedList[i].ExpDate + "</p>"; 
            //redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-top:10px'>" + escapeHtml(RedeemedList[i].Offer_Name) + "</div>";
             redeemedDiv = redeemedDiv + "<div style='text-align:left'>" + escapeHtml(RedeemedList[i].Offer_Name) + "</div>";
            redeemedDiv = redeemedDiv + "</div></a></li>";
          */
            redeemedDiv = redeemedDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
            redeemedDiv = redeemedDiv + " <div class='grid urow uib_row_90 gridpad2 marginzero' data-uib='layout/row' data-ver='0'>"
            redeemedDiv = redeemedDiv + "<div style='text-align:right; padding:0px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed( " + i + ");''>";
            redeemedDiv = redeemedDiv + "Exp Date: " + escapeHtml(RedeemedList[i].ExpDate);
            redeemedDiv = redeemedDiv + "<img src='" + RedeemedList[i].MerchantURL + "' alt='" + RedeemedList[i].Merchant_Name +"' width='55%' style='float:left; padding-bottom:0px; padding-right:5px; padding-top:5px; padding-left:0px'></a></div>";
            redeemedDiv = redeemedDiv + "<div style='text-align:right; padding:0px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(" + i + ");'><img src='images/SelectButton.png' alt='' style='float:right; padding-bottom:0px; padding-top:5px; padding-right:0px;'></div></div>";
            redeemedDiv = redeemedDiv + " <div class='grid urow uib_row_92 gridpad2 marginzero' data-uib='layout/row' data-ver='0'>"
            redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-left:5px'><p>" + escapeHtml(RedeemedList[i].Valid_Locations) + "</p></div>";
            redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-left:5px; padding-top:0px'>" + escapeHtml(RedeemedList[i].Offer_Name) + "</div>";
            redeemedDiv = redeemedDiv + "</a></div></li>";
         

            }
        else {
            //redeemedDiv = redeemedDiv + "<li><div style='text-align:right; padding:10px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(";
            redeemedDiv = redeemedDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
            redeemedDiv = redeemedDiv + " <div class='grid urow uib_row_90 gridpad2 marginzero' data-uib='layout/row' data-ver='0'>"
            redeemedDiv = redeemedDiv + "<div style='text-align:right; padding:0px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed( "+ i + ");'";
            redeemedDiv = redeemedDiv + "'><img src='" + RedeemedList[i].MerchantURL + "' alt='" + RedeemedList[i].Merchant_Name + "' width='25%' style='float:left; padding-bottom:0px; padding-right:0px; padding-left:0px'>Expiration Date: " + escapeHtml(RedeemedList[i].ExpDate) + "</a></div>";
            redeemedDiv = redeemedDiv + "<div style='text-align:right; padding:0px'><a href='#' style='color:black; text-decoration:none;' onclick='showRedeemed(" + i +");'><img src='images/SelectButton.png' alt='' style='float:right; padding-bottom:0px; padding-top:10px; padding-right:0px;'></div></div>";
            redeemedDiv = redeemedDiv + " <div class='grid urow uib_row_92 gridpad2 marginzero' data-uib='layout/row' data-ver='0'>"
            redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-left:5px'><p>" + escapeHtml(RedeemedList[i].Valid_Locations) + "</p></div>";
            redeemedDiv = redeemedDiv + "<div style='text-align:left; padding-left:5px; padding-top:0px'>" + escapeHtml(RedeemedList[i].Offer_Name) + "</div>";
            redeemedDiv = redeemedDiv + "</a></div></li>";
        }

    }
    
        }
        redeemedDiv = redeemedDiv + "</ul>";
        document.getElementById("offersRedeemed").innerHTML = redeemedDiv;
        document.getElementById("offersCurrent").innerHTML = redeemedDiv;
       

    
    
        }
        else
        {
            navigator.notification.alert(GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmNothing,"Error",'OK');
        }
    }
    else
    {
        navigator.notification.alert("Request Failed",confirmNothing,"Error",'OK');
    }

}

function wsGetCurrentOffers() {
    var soapMessage = wsBuildMsg('Get_Redeem_Offers_24',
                                  soapParm('strCardNo', cardNo));

    $.ajax({
        url: wsUrl,
        type: "POST",
        dataType: "xml",
        data: soapMessage,
        complete: endGetRedeemedOffers,
        contentType: "text/xml; charset=\"utf-8\""
    });

    return false;
}


function wsGetOffersByZip(zipCode)
{
    var distance = "100";
    var category = "1";
    var searchTerms = "";
    var zipCode = document.getElementById("txtzipCode").value;
    var soapMessage =  wsBuildMsg('Get_Offers',
                                  soapParm('strZip', zipCode) +
                                  soapParm('intMiles', distance) +
                                  soapParm('strSearch', searchTerms));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endGetOffers,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}

function wsGetOffers(lat, long)
{
    var distance = "100";
    var category = "1";
    var searchTerms = "";
    var soapMessage =  wsBuildMsg('Get_Offers',
                                  soapParm('dblLat', lat) +
                                  soapParm('dblLong', long) +
                                  soapParm('intMiles', distance) +
                                  //soapParm('intCategory',category) +
                                  soapParm('strSearch', searchTerms));

    $.ajax({
           url: wsUrl,
           type: "POST",
           dataType: "xml",
           data: soapMessage,
           complete: endGetOffers,
           contentType: "text/xml; charset=\"utf-8\""
           });

    return false;
}


function updateOfferListDiv()
{
    //Valid OfferList[i] items:
    //  OfferList[i].Active
    //  OfferList[i].Address1
    //  OfferList[i].Address2
    //  OfferList[i].Category_ID
    //  OfferList[i].Category_Name
    //  OfferList[i].City
    //  OfferList[i].CreateDateTime
    //  OfferList[i].Dis
    //  OfferList[i].Disclaimer
    //  OfferList[i].EndDate
    //  OfferList[i].Folder_ID
    //  OfferList[i].ID
    //  OfferList[i].Image1
    //  OfferList[i].Image2
    //  OfferList[i].ImgURL
    //  OfferList[i].Location_Zip
    //  OfferList[i].Merchant_Folder_ID
    //  OfferList[i].Merchant_ID
    //  OfferList[i].Merchant_Name
    //  OfferList[i].Offer_Details
    //  OfferList[i].Offer_Name
    //  OfferList[i].Offer_Type_ID
    //  OfferList[i].StartDate
    //  OfferList[i].State
    //  OfferList[i].Telephone
    //  OfferList[i].Test
    //  OfferList[i].Valid_Locations
    //  OfferList[i].View_Count
    //  OfferList[i].Zip
    //  OfferList[i].lat
    //  OfferList[i].long

    var i;

    var catList = document.getElementById("catList");
    var selected = catList.options[catList.selectedIndex].value;
    var imagedefinition;

    //var newDiv = "<ul class='list' data-appbuilder-object='list' style=''>";
    var newDiv = "<ul class='list widget uib_w_48 d-margins' data-uib='app_framework/listvie' data-ver='0'>";
        
    if(OfferList.length==0)
    {
        newDiv = newDiv + "No offers found.";
    }
    else
    {
        for (i=0; i<OfferList.length; i++)
        {
            if (selected == "All" || selected == OfferList[i].Category_Name)
            {
                //imagedefinition = OfferList[i].ImgURL
               
                //if (imagedefinition = undefined) {
                
                //    imagetext = "<div style='text-align:left; padding-left:5px; white-space: nowrap; overflow: hidden;'><p>" + OfferList[i].Merchant_Name + "</p></div>"
                //}
                //else
                //{
                //  imagetext = "<img src='" + OfferList[i].ImgURL + "' alt='" + OfferList[i].Merchant_Name + "' style='float:left; padding-bottom:10px; padding-right:10px; padding-left:10px'>"
                //}

                if (screen.width<500)
                {
                //newDiv = newDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
                //newDiv = newDiv + "<div style='text-align:right; padding:5px;'><a href='#' style='color:black; text-decoration:none;' onclick='selectOffer(";
                //newDiv = newDiv + '"' + OfferList[i].ID + '")';
                //newDiv = newDiv + "'><div style='padding-right:5px; padding-bottom:10px'><img src='" + OfferList[i].ImgURL + "' alt='Merchant Name' width='40%' style='float:left;'></div>";
                //newDiv = newDiv + "<div><img src='images/SelectButton.png' alt='' style='float:right; padding-right:0px;'></div>";
                //newDiv = newDiv + "Dist. " + OfferList[i].Dis + "m";
                //newDiv = newDiv + "<p>" + OfferList[i].Valid_Locations + "</p>";
                //newDiv = newDiv + "<div style='text-align:left; padding-left:5px; padding-top:5px'>" + OfferList[i].Offer_Name + "</div>";
                //newDiv = newDiv + "</a></div></li>";
                newDiv = newDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
                newDiv = newDiv + "<div style='text-align:right; padding:5px;'><a href='#' style='color:black; text-decoration:none;' onclick='selectOffer(";
                newDiv = newDiv + '"' + OfferList[i].ID + '")';
                newDiv = newDiv + "'><div style='padding-right:5px; padding-bottom:15px'><img src='" + OfferList[i].ImgURL + "' alt='" + OfferList[i].Merchant_Name + "' width='45%' style='float:left;'></div>";
                newDiv = newDiv + "<div><img src='images/SelectButton.png' alt='' width='10%' style='float:right; padding-right:0px;'></div>";
                newDiv = newDiv + "Dist. " + OfferList[i].Dis + "m";
                newDiv = newDiv + "<p style='padding-top:10px; text-align:left;'>" + OfferList[i].Valid_Locations + "</p>";
                newDiv = newDiv + "<div style='text-align:left;'>" + OfferList[i].Offer_Name + "</div>";
                newDiv = newDiv + "</a></div></li>";

                }
                else
                {
                newDiv = newDiv + "<li class='widget uib_w_49' data-uib='app_framework/listitem' data-ver='0'>";
                newDiv = newDiv + "<div style='text-align:right; padding:10px;'><a href='#' style='color:black; text-decoration:none;' onclick='selectOffer(";
                newDiv = newDiv + '"' + OfferList[i].ID + '")';
                //newDiv = newDiv + "'><img src='" + imagetext + "' alt='" + OfferList[i].Merchant_Name + "' style='float:left; padding-bottom:10px; padding-right:10px; padding-left:10px'>";
                newDiv = newDiv + "'><img src='" + OfferList[i].ImgURL + "' alt='" + OfferList[i].Merchant_Name + "' style='float:left;  padding-bottom:10px; padding-right:10px; padding-left:10px'>";
                //newDiv = newDiv + "'><div style='text-align:left; padding-left:5px; white-space: nowrap; overflow: hidden;'><p>" + OfferList[i].Merchant_Name + "</p></div>";
                //newDiv = newDiv + "'>" + imagetext;
                newDiv = newDiv + "<img src='images/SelectButton.png' alt='' style='float:right; padding-bottom:5px; padding-top:10px; padding-right:0px;'>";
                newDiv = newDiv + "Dist." + OfferList[i].Dis + "m";
                newDiv = newDiv + "<div style='text-align:left; padding-left:5px; white-space: nowrap; overflow: hidden;'><p>" + OfferList[i].Valid_Locations + "</p></div>";
                newDiv = newDiv + "<div style='text-align:left; padding-left:5px; padding-top:0px'>" + OfferList[i].Offer_Name + "</div>";
                newDiv = newDiv + "</a></div></li>";
                    
                    
                }
            }
        }
    }
    
    
    newDiv = newDiv + "</ul>";
    document.getElementById("offers").innerHTML = newDiv;
    document.getElementById("imgLoading").innerHTML = "<div id='imgLoading' class='widget uib_w_73 scale-image hide' data-uib='media/img' data-ver='0'><img src='images/spinner.gif' alt='Loading....'></div>";
    
    
   
    
}

function endGetOffers(xmlHttpRequest, status)
{
    if (status == 'success')
    {
        if (GetElement(xmlHttpRequest.responseXML,'strResponse').toLowerCase()=='true')
        {
        OfferList = GetComplexElements(htmlDecode( GetElement(xmlHttpRequest.responseText, "Get_OffersResult")), "OFFER");

        var i;
                  var categories = new Array();
    if(OfferList.length==0)
        {
         
        }
    else
    {
  
        for (i=0; i<OfferList.length; i++)
        {
            if(categories.indexOf(OfferList[i].Category_Name)<0)
            {
                categories.push(OfferList[i].Category_Name);
            }
        }
    }
    
        categories.sort();


        //var catList = document.getElementById("catList");

        //$("#catList").empty();

        var html = '<option value="All" selected="true">All</Option>';
        for(i=0; i<categories.length; i++)
        {
            html = html + '<option value="' + categories[i] + '">' + categories[i] + '</Option>';
        }
        var selcatListDiv = "<label class='narrow-control label-top-left' for='catList'>Category</label><select class='wide-control' id='catList' onchange='updateOfferListDiv()'>" + html + "</select>";
            //$('#catList').append(html);
        document.getElementById("selcatListspot").innerHTML = selcatListDiv;

        updateOfferListDiv();
        //$.ui.unblockUI();
        }
        else
        {
            //$.ui.unblockUI();
            navigator.notification.alert(GetElement(xmlHttpRequest.responseXML,'strResponse'),confirmNothing,"Error",'OK');
        }
    }
    else
    {
        //$.ui.unblockUI();
        navigator.notification.alert("Request Failed",confirmNothing,"Error",'OK');
    }

}


function onGeoSuccess(position) 
{
    //showPanel('offerspanel');
    //var newDiv = " ";
    //document.getElementById("offers").innerHTML = newDiv;
    //document.getElementById("imgLoading").innerHTML = "<div id='imgLoading' class='widget uib_w_73 scale-image' data-uib='media/img' data-ver='0'><img src='images/spinner.gif' alt='Loading....'></div>";
    //activate_subpage("#uib_page_offers");
    wsGetOffers(position.coords.latitude, position.coords.longitude);
    
};

function onGeoError(error) 
{
    if (error.code == 3 && geoOptions.enableHighAccuracy==true)
    {
        //Try again using coarse location (network)
        geoOptions = { timeout: 10000, enableHighAccuracy: false};
        navigator.geolocation.getCurrentPosition(onGeoSuccess, onGeoError, geoOptions);
        
    }
    else
    {
        //$.ui.unblockUI();
        //Show an error that geolocation could not be found.  Maybe they should try searching by zip code.
       navigator.notification.alert('code: ' + error.code + '\n' + 'message: ' + error.message + '\n', confirmNothing, "Error");
    }
}

function GetLocation()
{
    //$.ui.blockUI(0.9);
    //showPanel('waiting'); 
    //activate_subpage("#uib_page_Loadingsub");
    
    geoOptions = { timeout: 10000, enableHighAccuracy: true};
    navigator.geolocation.getCurrentPosition(onGeoSuccess, onGeoError, geoOptions);
}

function clearScreens (){
    //This clears the screens so that it doesn't show old data while it is loading new data.
 
     var newDiv = " ";
    document.getElementById("offers").innerHTML = newDiv;
    document.getElementById("imgLoading").innerHTML = "<div id='imgLoading' class='widget uib_w_73 scale-image' data-uib='media/img' data-ver='0'><img src='images/spinner.gif' alt='Loading....'></div>";
    
    var redeemedDiv = " ";
    document.getElementById("offersRedeemed").innerHTML = redeemedDiv;
    document.getElementById("offersCurrent").innerHTML = redeemedDiv;

    var selcatListDiv = " ";
    document.getElementById("selcatListspot").innerHTML = selcatListDiv;
    
}




